#!/usr/bin/env python

# Copyright and license: Please refer to LICENSE.TXT

import sys
import os
import os.path
import string
import re
import time
import glob

_selfpath=(os.path.dirname(os.path.realpath(__file__)).split('/'))[:-1]
_selfpath.append('pylibs')
_libspath='/'.join(_selfpath)
sys.path.append(_libspath)

from castiron import *

sys.path.append(CORE_PATH_BASE+'/pylibs')

from s2p import *
from s2p_logger import *

CASTIRON_CONF_SYSTEM = xml_to_array(CASTIRON_PATH_BASE+'/config/misc.xml')

if CASTIRON_CONF_SYSTEM['rdate']['enabled'] != 'true': sys.exit(0)
ntp_server=CASTIRON_CONF_SYSTEM['rdate']['server']

if not ntp_server: sys.exit(0)
if re.search(r'[^\w\.\-\_]', ntp_server): sys.exit(-1)

os.system('rdate -s '+ntp_server)
os.system('hwclock --systohc')

s2p_log("sys", "info", "Internal clock sync with "+ntp_server)