<?php
	class CI_SETTINGS_MEDIA extends CI_CONFIG
	{
		function get_config_file()
		{
			return CI_PATH_CONFIG.'/media.xml';
		}

		function get_list()
		{
			$list =& $this->get_raw_list();
			
			for ($i=0; $i<sizeof($list); $i++)
			{
				$list[$i]=$this->get_map($list[$i]);
				$list[$i]['destination']=$list[$i]['email_to'] ? $list[$i]['email_to'] : 'ftp://'.$list[$i]['ftp_server'].'/'.$list[$i]['ftp_path'];
			}
			
			return $list;
		}

		function get_rmap($info)
		{
			return array(
				'enabled'		=> $info['enabled'],
				'id'			=> $info['id'],
				'mode'			=> $info['mode'],
				'desc'			=> $info['desc'],
				'email'	=> array(
					'from'		=> $info['email_from'],
					'to'		=> $info['email_to'],
					'smtp'		=> $info['email_smtp']
				),
				'ftp'	=> array(
					'server'	=> $info['ftp_server'],
					'port'		=> $info['ftp_port'],
					'path'		=> $info['ftp_path'],
					'username'	=> $info['ftp_username'],
					'password'	=> $info['ftp_password']
				)
			);
		}

		function get_map($info)
		{
			return array(
				'enabled'		=> $info['enabled'],
				'id'			=> $info['id'],
				'mode'			=> $info['mode'],
				'desc'			=> $info['desc'],
				'email_from'	=> $info['email']['from'],
				'email_to'		=> $info['email']['to'],
				'email_smtp'	=> $info['email']['smtp'],
				'ftp_server'	=> $info['ftp']['server'],
				'ftp_port'		=> $info['ftp']['port'],
				'ftp_path'		=> $info['ftp']['path'],
				'ftp_username'	=> $info['ftp']['username'],
				'ftp_password'	=> $info['ftp']['password']
			);
		}

		function get_info($id)
		{
			if (!$id) return array('enabled' => 'true');

			return parent::get_info($id);
		}
		
		function task_save($info)
		{
			if ($info['mode'] == 'email')
			{
				if (!$info['email_from'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'email_from',
							'desc'		=> ci_lbl('libsettings_media.error.missing-email_from')
						)
					);

				if (!$info['email_to'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'email_to',
							'desc'		=> ci_lbl('libsettings_media.error.missing-email_to')
						)
					);

				if (!$info['email_smtp'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'email_smtp',
							'desc'		=> ci_lbl('libsettings_media.error.missing-email_smtp')
						)
					);
			}
			elseif ($info['mode'] == 'ftp')
			{
				if (!$info['ftp_server'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'ftp_server',
							'desc'		=> ci_lbl('libsettings_media.error.missing-ftp_server')
						)
					);

				if (!$info['ftp_port'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'ftp_port',
							'desc'		=> ci_lbl('libsettings_media.error.missing-ftp_port')
						)
					);

				if (!$info['ftp_username'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'ftp_username',
							'desc'		=> ci_lbl('libsettings_media.error.missing-ftp_username')
						)
					);

				if (!$info['ftp_password'])
					return ci_response_error(
						'field',
						array(
							'fieldname' => 'ftp_password',
							'desc'		=> ci_lbl('libsettings_media.error.missing-ftp_password')
						)
					);
			}

			
			/* New item, let's create one ID */
			if (!$info['id'])			$info['id']=md5(uniqid(''));

			/* Compose fields */
			$fields=$this->get_rmap($info);

			/* Retrieve item position */
			$n=$this->get_n($info['id']);

			/* Save */
			$list =& $this->get_raw_list();
			$list[$n]=$fields;

			$this->save_raw_config($list);
			return ci_response_ok();
		}
	}
?>