<?php
	class CI_TABLES
	{
		private $options;
		private $headers;
		private $lines;
		private $editable;
		private $delete;
		private $id;
		
		function CI_TABLES($id=NULL)
		{
			$this->sortable=false;
			$this->headers=array();
			$this->lines=array();

			if (is_null($id)) $id=uniqid('table_');
			$this->id=$id;
		}

		function set_option($k, $v)
		{
			$this->options[$k]=$v;
		}

		function set_headers($headers)
		{
			$this->headers=$headers;
		}
		
		function add_line($line, $info=array())
		{
			array_push($this->lines, array('line' => $line, 'info' => $info));
		}

		function get()
		{
			global $CI_URI_BASE;
			
			$out="<table class=\"table\">";

			if ($this->options['dot'])		$out.="<th class=\"table icon\">&nbsp;</th>";
			if ($this->options['edit'])		$out.="<th class=\"table icon\">&nbsp;</th>";
			
			foreach ($this->headers as $k => $v)
				$out.="<th class=\"table td_".$k."\">".$v."</th>";

			if ($this->options['delete'])	$out.="<th class=\"table icon\">&nbsp;</th>";
			if ($this->options['toggle'])	$out.="<th class=\"table icon\">&nbsp;</th>";
			if ($this->options['reload'])	$out.="<th class=\"table icon\">&nbsp;</th>";
			
 			$out.="<tbody class=\"table\" id=\"".$this->id."\">";
 			foreach ($this->lines as $l)
 			{
 				$line=$l['line'];
 				$info=$l['info'];

 				$extra_class=($this->options['sort'] ? 'sortable' : '');
 				if ($this->options['toggle'] && !$info['enabled']) $extra_class="disabled";
 				
 				$out.="<tr class=\"table\">";

 				if ($this->options['dot']) $out.="<td class=\"table icon $extra_class\"><img alt=\"edit\" src=\"$CI_URI_BASE/icons/tables/dot.png\" /></td>";
 				if ($this->options['edit']) $out.="<td class=\"table icon $extra_class\"><a onmouseup=\"on_table_event('".$this->id."', 'edit', '".$info['id']."')\" href=\"#\"><img alt=\"edit\" src=\"$CI_URI_BASE/icons/tables/edit.png\" /></a></td>";

 				foreach (array_keys($this->headers) as $k)
				{
					$out.="<td class=\"table $extra_class td_".$k."\">";
					
					if ($this->options['edit'] && $this->options['clickable'] == $k)
						$out.="<a onmouseup=\"on_table_event('".$this->id."', 'edit', '".$info['id']."')\" href=\"#\">";
						
 					$out.=$line[$k];

 					if ($this->options['edit'] && $this->options['clickable'] == $k)
 						$out.='</a>';

 					$out.="</td>";
 				}

				if ($this->options['delete']) $out.="<td class=\"table icon $extra_class\"><a href=\"javascript:on_table_event('".$this->id."', 'delete', '".$info['id']."')\"><img alt=\"delete\" src=\"$CI_URI_BASE/icons/tables/delete.png\" /></a></td>";
				if ($this->options['toggle']) $out.="<td class=\"table icon $extra_class\"><a href=\"javascript:on_table_event('".$this->id."', 'toggle', '".$info['id']."')\"><img alt=\"toggle\" src=\"$CI_URI_BASE/icons/tables/toggle_".($info['enabled'] ? 'on' : 'off').".png\" /></a></td>";
				if ($this->options['reload']) $out.="<td class=\"table icon $extra_class\"><a href=\"javascript:on_table_event('".$this->id."', 'reload', '".$info['id']."')\"><img alt=\"reload\" src=\"$CI_URI_BASE/icons/tables/reload.png\" /></a></td>";

 				$out.="</tr>";
 			}
 			$out.="</tbody>";
 			$out.="</table>";

 			if ($this->options['sort'])
 			{
				$out.="<script type=\"text/javascript\">";
					$out.="new Sortables($('".$this->id."'), {";
						$out.="ghost: true,";
						$out.="onDragComplete: function(element, ghost) {";
							$out.="on_table_event('".$this->id."', 'sort', this.serialize());";
							$out.="element.setStyle('opacity', 1);";
							$out.="ghost.remove();";
							$out.="this.trash.remove();";
							$out.="this.elements = this.list.getChildren();";
						$out.="}";
					$out.="})";
				$out.="</script>";
			}

			return $out;
		}
	}
?>